#Dim All
#REGISTER NONE
#COMPILE EXE
#OPTION VERSION4

' The following constants define the minimum required platform.  The minimum required
' platform is the earliest version of Windows, Internet Explorer etc. that has the
' necessary features to run your application.  Wnen defined, they enable features
' available on platform versions up to and including the version specified.
%NTDDI_VERSION                          		= &H05010000
%WINVER                                 		= &H0501
%WIN32_WINNT                            		= &H0501
%WIN32_IE                               		= &H0600
%UNICODE                                		= 1

#Include Once "WIN32API.INC"

#Include Once "Layout32_sll.inc"

#Link "Layout32.sll"

#Resource Manifest, 1, "FlickerFree.xml"

'--------------------------- [ Control Identifiers ] ---------------------------

%IDC_FORM1_GROUP1                           = 101
%IDC_FORM1_RADIO1                           = 102
%IDC_FORM1_RADIO2                           = 103
%IDC_FORM1_RADIO3                           = 104
%IDC_FORM1_RADIO4                           = 105
%IDC_FORM1_GROUP2                           = 107
%IDC_FORM1_RADIO5                           = 108
%IDC_FORM1_RADIO6                           = 109
%IDC_FORM1_RADIO7                           = 110
%IDC_FORM1_RADIO8                           = 111

Global  ghInstance    As DWord    ' handle of the application instance

'-------------------------------------------------------------------------------
'
' PROCEDURE: WinMain
' PURPOSE:   Program entry point, calls initialization function, processes
'            message loop.
'
'-------------------------------------------------------------------------------

FUNCTION WinMain _
  ( _
  BYVAL hInstance     AS DWORD, _         ' handle of current instance
  BYVAL hPrevInstance AS DWORD, _         ' handle of previous instance(not used in Win32)
  BYVAL pszCmdLine    AS WSTRINGZ PTR, _  ' address of command line
  BYVAL nCmdShow      AS LONG _           ' show state of window
  ) AS LONG

  LOCAL szClassName     AS WSTRINGZ * %MAX_PATH     ' class name
  LOCAL twcx            AS WNDCLASSEX               ' class information
  LOCAL tmsg            AS tagMsg                   ' message information
  Local hWnd            As DWord                    ' handle of main window

  ' Save the handle of the application instance
  ghInstance = hInstance

  ' Register the Form1 window
  szClassName        = "Form1_Class"
  twcx.cbSize        = SIZEOF(twcx)                               ' size of WNDCLASSEX structure
  twcx.style         = %CS_DBLCLKS                                ' class styles
  twcx.lpfnWndProc   = CODEPTR(Form1_WndProc)                     ' address of window procedure used by class
  twcx.cbClsExtra    = 0                                          ' extra class bytes
  twcx.cbWndExtra    = 0                                          ' extra window bytes
  twcx.hInstance     = ghInstance                                 ' instance of the process that is registering the window
  twcx.hIcon         = LoadIcon(%NULL, BYVAL %IDI_APPLICATION)    ' handle of class icon
  twcx.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)        ' handle of class cursor
  twcx.hbrBackground = %COLOR_BTNFACE + 1                         ' brush used to fill background of window's client area
  twcx.lpszMenuName  = %NULL                                      ' resource identifier of the class menu
  twcx.lpszClassName = VARPTR(szClassName)                        ' class name
  twcx.hIconSm       = %NULL                                      ' handle of small icon shown in caption/system Taskbar
  If RegisterClassEx(twcx) = 0 Then
    FUNCTION = %FALSE
    EXIT FUNCTION
  END IF

  ' Create the Form1 window
  hWnd = CreateWindowEx(%WS_EX_WINDOWEDGE OR %WS_EX_COMPOSITED, _                     ' extended styles
                        "Form1_Class", _                                              ' class name
                        "Reducing Flickering", _                                      ' caption
                        %WS_OVERLAPPEDWINDOW OR %WS_VISIBLE OR %WS_THICKFRAME OR _    ' window styles
                        %WS_CLIPCHILDREN, _
                        70, 130, _                                                    ' left, top
                        294, 202, _                                                   ' width, height
                        %NULL, %NULL, _                                               ' handle of owner, menu handle
                        ghInstance, BYVAL %NULL)                                      ' handle of instance, creation parameters
  ' If window could not be created, return "failure"
  If hWnd = %NULL Then
    Function = %FALSE
    Exit Function
  End If

  ' Make the window visible; update its client area
  ShowWindow hWnd, nCmdShow
  UpdateWindow hWnd

  ' Main message loop of program.
  ' Acquire and dispatch messages until a WM_QUIT message is received.
  While GetMessage(tmsg, ByVal %NULL, 0, 0) > 0
    If (hWnd = %NULL) Or (IsDialogMessage(hWnd, tmsg) = 0) Then
      TranslateMessage tmsg
      DispatchMessage tmsg
    End If
  Wend

  Function = tmsg.wParam

END FUNCTION

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WndProc
' PURPOSE:   Processes messages for the Form1 window.
'
'-------------------------------------------------------------------------------

FUNCTION Form1_WndProc _
  ( _
  BYVAL hWnd    AS DWORD, _ ' window handle
  BYVAL uMsg    AS DWORD, _ ' type of message
  BYVAL wParam  AS DWORD, _ ' first message parameter
  BYVAL lParam  AS LONG _   ' second message parameter
  ) EXPORT AS LONG

  LOCAL tlb           AS LOGBRUSH   ' specifies information used to create background brush
  LOCAL trc           AS RECT       ' bounding or formatting rectangle
  LOCAL hWndChild     AS DWORD      ' handle of child window
  LOCAL hFont         AS DWORD      ' handle of font used by form
  LOCAL hBrush        AS DWORD      ' handle of background brush of parent or control
  LOCAL lMsgResult    AS LONG       ' value returned to message after message is processed

  SELECT CASE uMsg
    CASE %WM_COMMAND

    CASE %WM_ERASEBKGND
      GetClientRect hWnd, trc
      ' Create custom brush
      tlb.lbStyle = %BS_SOLID
      tlb.lbColor = &H00A09E5F???
      tlb.lbHatch = 0
      hBrush = CreateBrushIndirect(tlb)
      ' Erase background
      FillRect wParam, trc, hBrush
      DeleteObject hBrush
      FUNCTION = %TRUE
      EXIT FUNCTION

    CASE %WM_CTLCOLORSTATIC

      SELECT CASE GetParent(lParam)
        CASE hWnd

          SELECT CASE GetDlgCtrlID(lParam)
            Case %IDC_FORM1_GROUP1 To %IDC_FORM1_RADIO8
              SetBkMode wParam, %TRANSPARENT
              ' Return handle of brush used to paint background
              FUNCTION = GetStockObject(%NULL_BRUSH)
              EXIT FUNCTION
          End Select

      END SELECT

    CASE %WM_SETFOCUS
      ' Set the keyboard focus to the first control that is
      ' visible, not disabled, and has the WS_TABSTOP style
      SetFocus GetNextDlgTabItem(hWnd, %NULL, %FALSE)

    Case %WM_Close

    CASE %WM_QUERYENDSESSION

    CASE %WM_DESTROY
      PostQuitMessage 0
      FUNCTION = %FALSE
      EXIT FUNCTION

    Case %WM_GETFONT
      Function = GetStockObject(%DEFAULT_GUI_FONT)
      Exit Function

    CASE %WM_CREATE
      ' Create font used by container
      hFont = GetStockObject(%DEFAULT_GUI_FONT)

      ' Create the Radio1 radio button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Radio1", _                                          ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %BS_AUTORADIOBUTTON OR %BS_LEFT OR %BS_VCENTER, _    ' class styles
                                 24, 39, _                                            ' left, top
                                 104, 21, _                                           ' width, height
                                 hWnd, %IDC_FORM1_RADIO1, _                           ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the Radio2 radio button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Radio2", _                                          ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %BS_AUTORADIOBUTTON OR %BS_LEFT OR %BS_VCENTER, _    ' class styles
                                 24, 66, _                                            ' left, top
                                 104, 21, _                                           ' width, height
                                 hWnd, %IDC_FORM1_RADIO2, _                           ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the Radio3 radio button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Radio3", _                                          ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %BS_AUTORADIOBUTTON OR %BS_LEFT OR %BS_VCENTER, _    ' class styles
                                 24, 93, _                                            ' left, top
                                 104, 21, _                                           ' width, height
                                 hWnd, %IDC_FORM1_RADIO3, _                           ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the Radio4 radio button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Radio4", _                                          ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %BS_AUTORADIOBUTTON OR %BS_LEFT OR %BS_VCENTER, _    ' class styles
                                 24, 120, _                                           ' left, top
                                 104, 21, _                                           ' width, height
                                 hWnd, %IDC_FORM1_RADIO4, _                           ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the Group1 groupbox
      hWndChild = CreateWindowEx(%WS_EX_TRANSPARENT, _                                ' extended styles
                                 "Button", _                                          ' class name
                                 "Group1", _                                          ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_GROUP OR _
                                 %BS_GROUPBOX, _                                      ' class styles
                                 12, 12, _                                            ' left, top
                                 128, 141, _                                          ' width, height
                                 hWnd, %IDC_FORM1_GROUP1, _                           ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the Radio5 radio button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Radio1", _                                          ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %BS_AUTORADIOBUTTON OR %BS_LEFT OR %BS_VCENTER, _    ' class styles
                                 158, 39, _                                           ' left, top
                                 104, 21, _                                           ' width, height
                                 hWnd, %IDC_FORM1_RADIO5, _                           ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the Radio6 radio button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Radio2", _                                          ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %BS_AUTORADIOBUTTON OR %BS_LEFT OR %BS_VCENTER, _    ' class styles
                                 158, 66, _                                           ' left, top
                                 104, 21, _                                           ' width, height
                                 hWnd, %IDC_FORM1_RADIO6, _                           ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the Radio7 radio button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Radio3", _                                          ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %BS_AUTORADIOBUTTON OR %BS_LEFT OR %BS_VCENTER, _    ' class styles
                                 158, 93, _                                           ' left, top
                                 104, 21, _                                           ' width, height
                                 hWnd, %IDC_FORM1_RADIO7, _                           ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the Radio8 radio button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Radio4", _                                          ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %BS_AUTORADIOBUTTON OR %BS_LEFT OR %BS_VCENTER, _    ' class styles
                                 158, 120, _                                          ' left, top
                                 104, 21, _                                           ' width, height
                                 hWnd, %IDC_FORM1_RADIO8, _                           ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the Group2 groupbox
      hWndChild = CreateWindowEx(%WS_EX_TRANSPARENT, _                                ' extended styles
                                 "Button", _                                          ' class name
                                 "Group2", _                                          ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_GROUP OR _
                                 %BS_GROUPBOX, _                                      ' class styles
                                 146, 12, _                                           ' left, top
                                 128, 141, _                                          ' width, height
                                 hWnd, %IDC_FORM1_GROUP2, _                           ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Rules
      Layout_AddRule hWnd, %MOVE, %LEFT, %IDC_FORM1_GROUP2, %WIDTH
      Layout_AddRule hWnd, %MOVE, %LEFT, MakLng(%IDC_FORM1_RADIO5, %IDC_FORM1_RADIO8), %LEFT, %IDC_FORM1_GROUP2
      Layout_AddRule hWnd, %STRETCH, %RIGHT, MakLng(%IDC_FORM1_GROUP2, %IDC_FORM1_RADIO8), %RIGHT
      Layout_AddRule hWnd, %STRETCH, %RIGHT, MakLng(%IDC_FORM1_GROUP1, %IDC_FORM1_RADIO4), %LEFT, %IDC_FORM1_GROUP2
      ' Limits
      Layout_AddLimit hWnd, %FORM, 294, 202, 0, 202
  End Select

  FUNCTION = DefWindowProc(hWnd, uMsg, wParam, lParam)

END FUNCTION

