#Dim All
#REGISTER NONE
#COMPILE EXE
#OPTION VERSION4

' Notes
' This sample uses four sets of rules to change the way controls resize.

' The following constants define the minimum required platform.  The minimum required
' platform is the earliest version of Windows, Internet Explorer etc. that has the
' necessary features to run your application.  Wnen defined, they enable features
' available on platform versions up to and including the version specified.
%NTDDI_VERSION                          		= &H05010000
%WINVER                                 		= &H0501
%WIN32_WINNT                            		= &H0501
%WIN32_IE                               		= &H0600
%UNICODE                                		= 1

#Include Once "WIN32API.INC"
#Include Once "COMMCTRL.INC"

#Include Once "Layout32_sll.inc"

#Link "Layout32.sll"

#Resource Manifest, 1, "Fun.xml"

'--------------------------- [ Control Identifiers ] ---------------------------

%IDC_FORM1_EDIT1                            = 101
%IDC_FORM1_EDIT2                            = 102
%IDC_FORM1_EDIT3                            = 103
%IDC_FORM1_EDIT4                            = 104
%IDC_FORM1_EDIT5                            = 105
%IDC_FORM1_EDIT6                            = 106
%IDC_FORM1_TEXTBTN1                         = 107
%IDC_FORM1_TEXTBTN2                         = 108
%IDC_FORM1_TEXTBTN3                         = 109
%IDC_FORM1_TEXTBTN4                         = 110
%IDC_FORM1_TEXTBTN5                         = 111
%IDC_FORM1_TEXTBTN6                         = 112
%IDC_FORM1_LISTVIEW1                        = 113
%IDC_FORM1_RADIO1                           = 114
%IDC_FORM1_RADIO2                           = 115
%IDC_FORM1_RADIO3                           = 116
%IDC_FORM1_RADIO4                           = 117

Global  ghInstance      As DWord    ' handle of the application instance

'-------------------------------------------------------------------------------
'
' PROCEDURE: WinMain
' PURPOSE:   Program entry point, calls initialization function, processes
'            message loop.
'
'-------------------------------------------------------------------------------

FUNCTION WinMain _
  ( _
  BYVAL hInstance     AS DWORD, _         ' handle of current instance
  BYVAL hPrevInstance AS DWORD, _         ' handle of previous instance(not used in Win32)
  BYVAL pszCmdLine    AS WSTRINGZ PTR, _  ' address of command line
  BYVAL nCmdShow      AS LONG _           ' show state of window
  ) AS LONG

  LOCAL szClassName     AS WSTRINGZ * %MAX_PATH     ' class name
  LOCAL twcx            AS WNDCLASSEX               ' class information
  LOCAL tmsg            AS tagMsg                   ' message information
  LOCAL ticc            AS INIT_COMMON_CONTROLSEX   ' specifies common control classes to register
  Local hWnd            As DWord                    ' handle of main window

  ' Save the handle of the application instance
  ghInstance = hInstance

  ' Register the Form1 window
  szClassName        = "Form1_Class"
  twcx.cbSize        = SIZEOF(twcx)                               ' size of WNDCLASSEX structure
  twcx.style         = %CS_DBLCLKS                                ' class styles
  twcx.lpfnWndProc   = CODEPTR(Form1_WndProc)                     ' address of window procedure used by class
  twcx.cbClsExtra    = 0                                          ' extra class bytes
  twcx.cbWndExtra    = 0                                          ' extra window bytes
  twcx.hInstance     = ghInstance                                 ' instance of the process that is registering the window
  twcx.hIcon         = LoadIcon(%NULL, BYVAL %IDI_APPLICATION)    ' handle of class icon
  twcx.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)        ' handle of class cursor
  twcx.hbrBackground = %COLOR_BTNFACE + 1                         ' brush used to fill background of window's client area
  twcx.lpszMenuName  = %NULL                                      ' resource identifier of the class menu
  twcx.lpszClassName = VARPTR(szClassName)                        ' class name
  twcx.hIconSm       = %NULL                                      ' handle of small icon shown in caption/system Taskbar
  If RegisterClassEx(twcx) = 0 Then
    FUNCTION = %FALSE
    EXIT FUNCTION
  END IF

  ' Load the common controls library and
  ' specify the classes to register.
  ticc.dwSize = SizeOf(ticc)
  ticc.dwICC  = %ICC_LISTVIEW_CLASSES
  InitCommonControlsEx ticc

  ' Create the Form1 window
  hWnd = CreateWindowEx(%WS_EX_WINDOWEDGE, _                                          ' extended styles
                        "Form1_Class", _                                              ' class name
                        "Fun with Rules", _                                           ' caption
                        %WS_OVERLAPPEDWINDOW OR %WS_VISIBLE OR %WS_CLIPCHILDREN, _    ' window styles
                        70, 130, _                                                    ' left, top
                        527, 256, _                                                   ' width, height
                        %NULL, %NULL, _                                               ' handle of owner, menu handle
                        ghInstance, BYVAL %NULL)                                      ' handle of instance, creation parameters
  ' If window could not be created, return "failure"
  If hWnd = %NULL Then
    Function = %FALSE
    Exit Function
  End If

  ' Make the window visible; update its client area
  ShowWindow hWnd, nCmdShow
  UpdateWindow hWnd

  ' Main message loop of program.
  ' Acquire and dispatch messages until a WM_QUIT message is received.
  While GetMessage(tmsg, ByVal %NULL, 0, 0) > 0
    If (hWnd = %NULL) Or (IsDialogMessage(hWnd, tmsg) = 0) Then
      TranslateMessage tmsg
      DispatchMessage tmsg
    End If
  Wend

  Function = tmsg.wParam

END FUNCTION

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WndProc
' PURPOSE:   Processes messages for the Form1 window.
'
'-------------------------------------------------------------------------------

FUNCTION Form1_WndProc _
  ( _
  BYVAL hWnd    AS DWORD, _ ' window handle
  BYVAL uMsg    AS DWORD, _ ' type of message
  BYVAL wParam  AS DWORD, _ ' first message parameter
  BYVAL lParam  AS LONG _   ' second message parameter
  ) EXPORT AS LONG

  LOCAL szItem        AS WSTRINGZ * %MAX_PATH   ' working variable
  LOCAL tlvc          AS LVCOLUMN               ' specifies or receives the attributes of a listview column
  LOCAL tlvi          AS LVITEM                 ' specifies or receives the attributes of a listview item
  LOCAL ptnmhdr       AS NMHDR PTR              ' information about a notification message
  LOCAL hWndChild     AS DWORD                  ' handle of child window
  LOCAL hFont         AS DWORD                  ' handle of font used by form
  LOCAL lMsgResult    AS LONG                   ' value returned to message after message is processed

  SELECT CASE uMsg
    CASE %WM_COMMAND

      SELECT CASE LO(WORD, wParam)
        Case %IDC_FORM1_RADIO1
          IF HI(WORD, wParam) = %BN_CLICKED THEN
            ' Option1 - behaviour produced
            ' 1. The edit controls resize horizontally.
            ' 2. The buttons and list-view controls are not resized and are anchored
            '    to the right side of the form.
            ' 3. The Option1 and Option2 buttons are horizontally centered relative
            '    to the edit controls.
            ' 4. The Option3 and Option4 buttons are anchored to the left side of the
            '    list-view control.
            '
            ' 1. The form has a minimum width and height of 527 and 256 pixels respectively.
            ' 2. The maximum width of the form is unlimited and it cannot be resized smaller
            '    or larger than 256 pixels. That is, the form cannot be resized vertically.
            '
            ' Reset the size of the form
            SetWindowPos hWnd, %NULL, 0, 0, 527, 256, %SWP_NOZORDER Or %SWP_NOMOVE
            ' Delete the old layout rules
            Layout_Clear hWnd
            ' Rules
            Layout_AddRule hWnd, %STRETCH, %RIGHT, MakLng(%IDC_FORM1_EDIT1, %IDC_FORM1_EDIT6), %RIGHT
            Layout_AddRule hWnd, %MOVE, %RIGHT, MakLng(%IDC_FORM1_TEXTBTN1, %IDC_FORM1_LISTVIEW1), %RIGHT
            Layout_AddRule hWnd, %HCENTER, %GROUP, MakLng(%IDC_FORM1_RADIO1, %IDC_FORM1_RADIO2), %CONTROL, %IDC_FORM1_EDIT6
            Layout_AddRule hWnd, %MOVE, %LEFT, MakLng(%IDC_FORM1_RADIO3, %IDC_FORM1_RADIO4), %LEFT, %IDC_FORM1_LISTVIEW1
            ' Limits
            Layout_AddLimit hWnd, %FORM, 527, 256, 0, 256
          End If

        CASE %IDC_FORM1_RADIO2
          IF HI(WORD, wParam) = %BN_CLICKED THEN
            ' Option2 - behaviour produced
            ' 1. The buttons move relative to the width of the form and are not resized.
            ' 2. Both the edit and list-view controls resize horizontally.
            ' 3. The Option1 and Option2 buttons are horizontally centered relative
            '    to the edit controls
            ' 4. The Option3 and Option4 buttons are anchored to the left side of the
            '    list-view control.
            '
            ' 1. The form has a minimum width and height of 527 and 256 pixels respectively.
            ' 2. The maximum width of the form is unlimited and it cannot be resized smaller
            '    or larger than 256 pixels. That is, the form cannot be resized vertically.
            '
             SetWindowPos hWnd, %NULL, 0, 0, 527, 256, %SWP_NOZORDER Or %SWP_NOMOVE
            Layout_Clear hWnd
            ' Rules
            Layout_AddRule hWnd, %MOVE, %LEFT, MakLng(%IDC_FORM1_TEXTBTN1, %IDC_FORM1_TEXTBTN6), %WIDTH
            Layout_AddRule hWnd, %STRETCH, %RIGHT, MakLng(%IDC_FORM1_EDIT1, %IDC_FORM1_EDIT6), %LEFT, %IDC_FORM1_TEXTBTN1
            Layout_AddRule hWnd, %MOVE, %LEFT, %IDC_FORM1_LISTVIEW1, %RIGHT, %IDC_FORM1_TEXTBTN1
            Layout_AddRule hWnd, %STRETCH, %RIGHT, %IDC_FORM1_LISTVIEW1, %RIGHT
            Layout_AddRule hWnd, %HCENTER, %GROUP, MakLng(%IDC_FORM1_RADIO1, %IDC_FORM1_RADIO2), %CONTROL, %IDC_FORM1_EDIT6
            Layout_AddRule hWnd, %MOVE, %LEFT, MakLng(%IDC_FORM1_RADIO3, %IDC_FORM1_RADIO4), %LEFT, %IDC_FORM1_LISTVIEW1
            ' Limits
            Layout_AddLimit hWnd, %FORM, 527, 256, 0, 256
          End If

        CASE %IDC_FORM1_RADIO3
          IF HI(WORD, wParam) = %BN_CLICKED THEN
            ' Option3 - behaviour produced
            ' 1. The edit controls resize horizontally but do not grow beyond 300 pixels.
            ' 2. The buttons are anchored to the right side of the edit controls.
            ' 3. The list-view control starts growing after the edit controls stop growing.
            ' 4. The Option1 and Option2 buttons are horizontally centered relative
            '    to the edit controls
            ' 5. The Option3 and Option4 buttons are anchored to the left side of the
            '    list-view control.
            '
            ' 1. The edit controls have a maximum width of 300 pixels.
            ' 2. The form has a minimum width and height of 527 and 256 pixels respectively.
            ' 3. The maximum width of the form is unlimited and it cannot be resized smaller
            '    or larger than 256 pixels. That is, the form cannot be resized vertically.
            '
            SetWindowPos hWnd, %NULL, 0, 0, 527, 256, %SWP_NOZORDER Or %SWP_NOMOVE
            Layout_Clear hWnd
            ' Rules
            Layout_AddRule hWnd, %STRETCH, %RIGHT, MakLng(%IDC_FORM1_EDIT1, %IDC_FORM1_EDIT6), %RIGHT
            Layout_AddRule hWnd, %MOVE, %LEFT, MakLng(%IDC_FORM1_TEXTBTN1, %IDC_FORM1_TEXTBTN6), %RIGHT, %IDC_FORM1_EDIT1
            Layout_AddRule hWnd, %MOVE, %LEFT, %IDC_FORM1_LISTVIEW1, %RIGHT, %IDC_FORM1_TEXTBTN1
            Layout_AddRule hWnd, %STRETCH, %RIGHT, %IDC_FORM1_LISTVIEW1, %RIGHT
            Layout_AddRule hWnd, %HCENTER, %GROUP, MakLng(%IDC_FORM1_RADIO1, %IDC_FORM1_RADIO2), %CONTROL, %IDC_FORM1_EDIT6
            Layout_AddRule hWnd, %MOVE, %LEFT, MakLng(%IDC_FORM1_RADIO3, %IDC_FORM1_RADIO4), %LEFT, %IDC_FORM1_LISTVIEW1
            ' Limits
            Layout_AddLimit hWnd, MakLng(%IDC_FORM1_EDIT1, %IDC_FORM1_EDIT6), 0, 0, 300, 0
            Layout_AddLimit hWnd, %FORM, 527, 256, 0, 256
          End If

        CASE %IDC_FORM1_RADIO4
          IF HI(WORD, wParam) = %BN_CLICKED THEN
            ' Option4 - behaviour produced
            ' 1. The list-view control resize horizontally but does not grow beyond 300 pixels.
            ' 2. The buttons are anchored to the left side of the list-view control.
            ' 3. The edit controls grow horizontally with their right sides anchored to the
            '    left sides of the buttons.
            ' 4. The Option1 and Option2 buttons are horizontally centered relative
            '    to the edit controls
            ' 5. The Option3 and Option4 buttons are anchored to the left side of the
            '    list-view control.
            '
            ' 1. The list-view control has a maximum width of 300 pixels.
            ' 2. The form has a minimum width and height of 527 and 256 pixels respectively.
            ' 3. The maximum width of the form is unlimited and it cannot be resized smaller
            '    or larger than 256 pixels. That is, the form cannot be resized vertically.
            '
             SetWindowPos hWnd, %NULL, 0, 0, 527, 256, %SWP_NOZORDER Or %SWP_NOMOVE
            Layout_Clear hWnd
            ' Rules
            Layout_AddRule hWnd, %STRETCH, %WIDTH, %IDC_FORM1_LISTVIEW1, %WIDTH
            Layout_AddRule hWnd, %MOVE, %RIGHT, %IDC_FORM1_LISTVIEW1, %RIGHT
            Layout_AddRule hWnd, %MOVE, %RIGHT, MakLng(%IDC_FORM1_TEXTBTN1, %IDC_FORM1_TEXTBTN6), %LEFT, %IDC_FORM1_LISTVIEW1
            Layout_AddRule hWnd, %STRETCH, %RIGHT, MakLng(%IDC_FORM1_EDIT1, %IDC_FORM1_EDIT6), %LEFT, %IDC_FORM1_TEXTBTN1
            Layout_AddRule hWnd, %HCENTER, %GROUP, MakLng(%IDC_FORM1_RADIO1, %IDC_FORM1_RADIO2), %CONTROL, %IDC_FORM1_EDIT6
            Layout_AddRule hWnd, %MOVE, %LEFT, MakLng(%IDC_FORM1_RADIO3, %IDC_FORM1_RADIO4), %LEFT, %IDC_FORM1_LISTVIEW1

            ' Limits
            Layout_AddLimit hWnd, %IDC_FORM1_LISTVIEW1, 0, 0, 300, 0
            Layout_AddLimit hWnd, %FORM, 527, 256, 0, 256
          End If
      End Select

    CASE %WM_NOTIFY

    CASE %WM_SYSCOLORCHANGE
      ' Forward this message to common controls so that they will
      ' be properly updated when the user changes the color settings.
      SendMessage GetDlgItem(hWnd, %IDC_FORM1_LISTVIEW1), %WM_SYSCOLORCHANGE, wParam, lParam

    CASE %WM_SETFOCUS
      ' Set the keyboard focus to the first control that is
      ' visible, not disabled, and has the WS_TABSTOP style
      SetFocus GetNextDlgTabItem(hWnd, %NULL, %FALSE)

    Case %WM_Close

    Case %WM_QUERYENDSESSION

    Case %WM_Destroy
      PostQuitMessage 0
      Function = %FALSE
      Exit Function

    Case %WM_GETFONT
      Function = GetStockObject(%DEFAULT_GUI_FONT)
      Exit Function

    CASE %WM_CREATE
      ' Create and save the font used by the form
      hFont = GetStockObject(%DEFAULT_GUI_FONT)

      ' Create the Edit1 edit control
      hWndChild = CreateWindowEx(%WS_EX_CLIENTEDGE, _                                 ' extended styles
                                 "Edit", _                                            ' class name
                                 "Edit1", _                                           ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_GROUP OR %WS_TABSTOP OR _
                                 %ES_LEFT OR %ES_AUTOHSCROLL, _                       ' class styles
                                 12, 12, _                                            ' left, top
                                 211, 21, _                                           ' width, height
                                 hWnd, %IDC_FORM1_EDIT1, _                            ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the TextBtn1 text button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Button1", _                                         ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %BS_PUSHBUTTON OR %BS_CENTER OR %BS_VCENTER, _       ' class styles
                                 229, 12, _                                           ' left, top
                                 75, 23, _                                            ' width, height
                                 hWnd, %IDC_FORM1_TEXTBTN1, _                         ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the Edit2 edit control
      hWndChild = CreateWindowEx(%WS_EX_CLIENTEDGE, _                                 ' extended styles
                                 "Edit", _                                            ' class name
                                 "Edit2", _                                           ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %ES_LEFT OR %ES_AUTOHSCROLL, _                       ' class styles
                                 12, 41, _                                            ' left, top
                                 211, 21, _                                           ' width, height
                                 hWnd, %IDC_FORM1_EDIT2, _                            ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the TextBtn2 text button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Button2", _                                         ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %BS_PUSHBUTTON OR %BS_CENTER OR %BS_VCENTER, _       ' class styles
                                 229, 41, _                                           ' left, top
                                 75, 23, _                                            ' width, height
                                 hWnd, %IDC_FORM1_TEXTBTN2, _                         ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the Edit3 edit control
      hWndChild = CreateWindowEx(%WS_EX_CLIENTEDGE, _                                 ' extended styles
                                 "Edit", _                                            ' class name
                                 "Edit3", _                                           ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %ES_LEFT OR %ES_AUTOHSCROLL, _                       ' class styles
                                 12, 70, _                                            ' left, top
                                 211, 21, _                                           ' width, height
                                 hWnd, %IDC_FORM1_EDIT3, _                            ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the TextBtn3 text button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Button3", _                                         ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %BS_PUSHBUTTON OR %BS_CENTER OR %BS_VCENTER, _       ' class styles
                                 229, 70, _                                           ' left, top
                                 75, 23, _                                            ' width, height
                                 hWnd, %IDC_FORM1_TEXTBTN3, _                         ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the Edit4 edit control
      hWndChild = CreateWindowEx(%WS_EX_CLIENTEDGE, _                                 ' extended styles
                                 "Edit", _                                            ' class name
                                 "Edit4", _                                           ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %ES_LEFT OR %ES_AUTOHSCROLL, _                       ' class styles
                                 12, 99, _                                            ' left, top
                                 211, 21, _                                           ' width, height
                                 hWnd, %IDC_FORM1_EDIT4, _                            ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the TextBtn4 text button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Button4", _                                         ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %BS_PUSHBUTTON OR %BS_CENTER OR %BS_VCENTER, _       ' class styles
                                 229, 99, _                                           ' left, top
                                 75, 23, _                                            ' width, height
                                 hWnd, %IDC_FORM1_TEXTBTN4, _                         ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the Edit5 edit control
      hWndChild = CreateWindowEx(%WS_EX_CLIENTEDGE, _                                 ' extended styles
                                 "Edit", _                                            ' class name
                                 "Edit5", _                                           ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %ES_LEFT OR %ES_AUTOHSCROLL, _                       ' class styles
                                 12, 128, _                                           ' left, top
                                 211, 21, _                                           ' width, height
                                 hWnd, %IDC_FORM1_EDIT5, _                            ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the TextBtn5 text button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Button5", _                                         ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %BS_PUSHBUTTON OR %BS_CENTER OR %BS_VCENTER, _       ' class styles
                                 229, 128, _                                          ' left, top
                                 75, 23, _                                            ' width, height
                                 hWnd, %IDC_FORM1_TEXTBTN5, _                         ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the Edit6 edit control
      hWndChild = CreateWindowEx(%WS_EX_CLIENTEDGE, _                                 ' extended styles
                                 "Edit", _                                            ' class name
                                 "Edit6", _                                           ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %ES_LEFT OR %ES_AUTOHSCROLL, _                       ' class styles
                                 12, 157, _                                           ' left, top
                                 211, 21, _                                           ' width, height
                                 hWnd, %IDC_FORM1_EDIT6, _                            ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the TextBtn6 text button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Button6", _                                         ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %BS_PUSHBUTTON OR %BS_CENTER OR %BS_VCENTER, _       ' class styles
                                 229, 157, _                                          ' left, top
                                 75, 23, _                                            ' width, height
                                 hWnd, %IDC_FORM1_TEXTBTN6, _                         ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the ListView1 listview control
      hWndChild = CreateWindowEx(%WS_EX_CLIENTEDGE, _                                 ' extended styles
                                 "SysListView32", _                                   ' class name
                                 "", _                                                ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPCHILDREN OR _    ' window styles
                                 %WS_CLIPSIBLINGS OR %WS_TABSTOP OR _
                                 %LVS_REPORT OR %LVS_SINGLESEL OR _                   ' class styles
                                 %LVS_SHOWSELALWAYS OR %LVS_SHAREIMAGELISTS, _
                                 310, 12, _                                           ' left, top
                                 197, 168, _                                          ' width, height
                                 hWnd, %IDC_FORM1_LISTVIEW1, _                        ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      ' Set the extended class styles for the control
      SendMessage hWndChild, %LVM_SETEXTENDEDLISTVIEWSTYLE, 0, %LVS_EX_GRIDLINES OR %LVS_EX_FULLROWSELECT
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Add the columns
      szItem = "Country"
      tlvc.mask     = %LVCF_FMT OR %LVCF_WIDTH OR %LVCF_TEXT OR %LVCF_SUBITEM
      tlvc.fmt      = %LVCFMT_LEFT
      tlvc.cx       = 96
      tlvc.pszText  = VARPTR(szItem)
      tlvc.iSubItem = 0
      SendMessage hWndChild, %LVM_INSERTCOLUMN, 0, BYVAL VARPTR(tlvc)

      szItem = "Capital"
      tlvc.mask     = %LVCF_FMT OR %LVCF_WIDTH OR %LVCF_TEXT OR %LVCF_SUBITEM
      tlvc.fmt      = %LVCFMT_LEFT
      tlvc.cx       = 96
      tlvc.pszText  = VARPTR(szItem)
      tlvc.iSubItem = 1
      SendMessage hWndChild, %LVM_INSERTCOLUMN, 1, BYVAL VARPTR(tlvc)

      ' Add the items
      szItem = "Grenada"
      tlvi.mask       = %LVIF_TEXT
      tlvi.iItem      = 0
      tlvi.iSubItem   = 0
      tlvi.pszText    = VARPTR(szItem)
      SendMessage hWndChild, %LVM_INSERTITEM, 0, BYVAL VARPTR(tlvi)
      szItem = "St. Georges"
      tlvi.mask       = %LVIF_TEXT
      tlvi.iSubItem   = 1
      tlvi.pszText    = VARPTR(szItem)
      SendMessage hWndChild, %LVM_SETITEM, 0, BYVAL VARPTR(tlvi)

      szItem = "Trinidad and Tobago"
      tlvi.mask       = %LVIF_TEXT
      tlvi.iItem      = 1
      tlvi.iSubItem   = 0
      tlvi.pszText    = VARPTR(szItem)
      SendMessage hWndChild, %LVM_INSERTITEM, 0, BYVAL VARPTR(tlvi)
      szItem = "Port of Spain"
      tlvi.mask       = %LVIF_TEXT
      tlvi.iSubItem   = 1
      tlvi.pszText    = VARPTR(szItem)
      SendMessage hWndChild, %LVM_SETITEM, 0, BYVAL VARPTR(tlvi)

      szItem = "St. Lucia"
      tlvi.mask       = %LVIF_TEXT
      tlvi.iItem      = 2
      tlvi.iSubItem   = 0
      tlvi.pszText    = VARPTR(szItem)
      SendMessage hWndChild, %LVM_INSERTITEM, 0, BYVAL VARPTR(tlvi)
      szItem = "Castries"
      tlvi.mask       = %LVIF_TEXT
      tlvi.iSubItem   = 1
      tlvi.pszText    = VARPTR(szItem)
      SendMessage hWndChild, %LVM_SETITEM, 0, BYVAL VARPTR(tlvi)

      ' Auto-size the columns
      SendMessage hWndChild, %LVM_SETCOLUMNWIDTH, 0, MAK(LONG, %LVSCW_AUTOSIZE_USEHEADER, 0)
      SendMessage hWndChild, %LVM_SETCOLUMNWIDTH, 1, MAK(LONG, %LVSCW_AUTOSIZE_USEHEADER, 0)

      ' Create the Radio1 radio button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Option1", _                                         ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_GROUP OR %WS_TABSTOP OR _
                                 %BS_AUTORADIOBUTTON OR %BS_LEFT OR %BS_VCENTER, _    ' class styles
                                 56, 184, _                                           ' left, top
                                 63, 21, _                                            ' width, height
                                 hWnd, %IDC_FORM1_RADIO1, _                           ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the Radio2 radio button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Option2", _                                         ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %BS_AUTORADIOBUTTON OR %BS_LEFT OR %BS_VCENTER, _    ' class styles
                                 125, 184, _                                          ' left, top
                                 63, 21, _                                            ' width, height
                                 hWnd, %IDC_FORM1_RADIO2, _                           ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the Radio3 radio button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Option3", _                                         ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %BS_AUTORADIOBUTTON OR %BS_LEFT OR %BS_VCENTER, _    ' class styles
                                 310, 186, _                                          ' left, top
                                 63, 21, _                                            ' width, height
                                 hWnd, %IDC_FORM1_RADIO3, _                           ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the Radio4 radio button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Option4", _                                         ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %BS_AUTORADIOBUTTON OR %BS_LEFT OR %BS_VCENTER, _    ' class styles
                                 379, 186, _                                          ' left, top
                                 63, 21, _                                            ' width, height
                                 hWnd, %IDC_FORM1_RADIO4, _                           ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      SendMessage GetDlgItem(hWnd, %IDC_FORM1_RADIO1), %BM_CLICK, 0, 0
  End Select

  FUNCTION = DefWindowProc(hWnd, uMsg, wParam, lParam)

END FUNCTION

