#DIM ALL
#REGISTER NONE
#COMPILE EXE
#OPTION VERSION4

' The following constants define the minimum required platform.  The minimum required
' platform is the earliest version of Windows, Internet Explorer etc. that has the
' necessary features to run your application.  Wnen defined, they enable features
' available on platform versions up to and including the version specified.
%NTDDI_VERSION                          		= &H05010000
%WINVER                                 		= &H0501
%WIN32_WINNT                            		= &H0501
%WIN32_IE                               		= &H0600
%UNICODE                                		= 1

#Include Once "WIN32API.INC"

#INCLUDE ONCE "Layout32_dll.inc"

'#LINK "Layout32.sll"

'#RESOURCE MANIFEST, 1, "Resize.xml"

'--------------------------- [ Control Identifiers ] ---------------------------

%IDC_FORM1_EDIT1                            = 101

Global  ghInstance    As DWord    ' handle of the application instance

'-------------------------------------------------------------------------------
'
' PROCEDURE: WinMain
' PURPOSE:   Program entry point, calls initialization function, processes
'            message loop.
'
'-------------------------------------------------------------------------------

FUNCTION WinMain _
  ( _
  BYVAL hInstance     AS DWORD, _         ' handle of current instance
  BYVAL hPrevInstance AS DWORD, _         ' handle of previous instance(not used in Win32)
  BYVAL pszCmdLine    AS WSTRINGZ PTR, _  ' address of command line
  BYVAL nCmdShow      AS LONG _           ' show state of window
  ) AS LONG

  LOCAL szClassName     AS WSTRINGZ * %MAX_PATH     ' class name
  LOCAL twcx            AS WNDCLASSEX               ' class information
  LOCAL tmsg            AS tagMsg                   ' message information
  Local hWnd            As DWord                    ' handle of main window

  ' Save the handle of the application instance
  ghInstance = hInstance

  ' Register the Form1 window
  szClassName        = "Form1_Class"
  twcx.cbSize        = SIZEOF(twcx)                               ' size of WNDCLASSEX structure
  twcx.style         = %CS_DBLCLKS                                ' class styles
  twcx.lpfnWndProc   = CODEPTR(Form1_WndProc)                     ' address of window procedure used by class
  twcx.cbClsExtra    = 0                                          ' extra class bytes
  twcx.cbWndExtra    = 0                                          ' extra window bytes
  twcx.hInstance     = ghInstance                                 ' instance of the process that is registering the window
  twcx.hIcon         = LoadIcon(%NULL, BYVAL %IDI_APPLICATION)    ' handle of class icon
  twcx.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)        ' handle of class cursor
  twcx.hbrBackground = %COLOR_BTNFACE + 1                         ' brush used to fill background of window's client area
  twcx.lpszMenuName  = %NULL                                      ' resource identifier of the class menu
  twcx.lpszClassName = VARPTR(szClassName)                        ' class name
  twcx.hIconSm       = %NULL                                      ' handle of small icon shown in caption/system Taskbar
  If RegisterClassEx(twcx) = 0 Then
    FUNCTION = %FALSE
    EXIT FUNCTION
  END IF

  ' Create the Form1 window
  hWnd = CreateWindowEx(%WS_EX_WINDOWEDGE, _                                          ' extended styles
                        "Form1_Class", _                                              ' class name
                        "Introducing Layout32", _                                     ' caption
                        %WS_OVERLAPPEDWINDOW OR %WS_VISIBLE OR %WS_CLIPCHILDREN, _    ' window styles
                        70, 130, _                                                    ' left, top
                        307, 200, _                                                   ' width, height
                        %NULL, %NULL, _                                               ' handle of owner, menu handle
                        ghInstance, BYVAL %NULL)                                      ' handle of instance, creation parameters
  ' If window could not be created, return "failure"
  If hWnd = %NULL Then
    Function = %FALSE
    Exit Function
  End If

  ' Make the window visible; update its client area
  ShowWindow hWnd, nCmdShow
  UpdateWindow hWnd

  ' Main message loop of program.
  ' Acquire and dispatch messages until a WM_QUIT message is received.
  While GetMessage(tmsg, ByVal %NULL, 0, 0) > 0
    If (hWnd = %NULL) Or (IsDialogMessage(hWnd, tmsg) = 0) Then
      TranslateMessage tmsg
      DispatchMessage tmsg
    End If
  Wend

  Function = tmsg.wParam

END FUNCTION

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WndProc
' PURPOSE:   Processes messages for the Form1 window.
'
'-------------------------------------------------------------------------------

FUNCTION Form1_WndProc _
  ( _
  BYVAL hWnd    AS DWORD, _ ' window handle
  BYVAL uMsg    AS DWORD, _ ' type of message
  BYVAL wParam  AS DWORD, _ ' first message parameter
  BYVAL lParam  AS LONG _   ' second message parameter
  ) EXPORT AS LONG

  LOCAL hWndChild   AS DWORD    ' handle of child window
  LOCAL hFont       AS DWORD    ' handle of font used by form

  SELECT CASE uMsg
    CASE %WM_COMMAND

      SELECT CASE LO(WORD, wParam)
        CASE %IDC_FORM1_EDIT1
          IF HI(WORD, wParam) = %EN_CHANGE THEN
          END IF

        CASE %IDOK
          IF HI(WORD, wParam) = %BN_CLICKED THEN
          END IF

        CASE %IDCANCEL
          IF HI(WORD, wParam) = %BN_CLICKED THEN
          END IF
      END SELECT

    CASE %WM_SETFOCUS
      ' Set the keyboard focus to the first control that is
      ' visible, not disabled, and has the WS_TABSTOP style
      SetFocus GetNextDlgTabItem(hWnd, %NULL, %FALSE)

    CASE %WM_KILLFOCUS

    CASE %WM_CLOSE

    CASE %WM_QUERYENDSESSION

    CASE %WM_DESTROY
      PostQuitMessage 0
      FUNCTION = %FALSE
      EXIT FUNCTION

    Case %WM_GETFONT
      Function = GetStockObject(%DEFAULT_GUI_FONT)
      Exit Function

    Case %WM_Create
      ' Create font used by container
      hFont = GetStockObject(%DEFAULT_GUI_FONT)

      ' Create the Edit1 edit control
      hWndChild = CreateWindowEx(%WS_EX_CLIENTEDGE, _                                 ' extended styles
                                 "Edit", _                                            ' class name
                                 "", _                                                ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_HSCROLL OR _         ' window styles
                                 %WS_VSCROLL OR %WS_CLIPSIBLINGS OR %WS_TABSTOP OR _
                                 %ES_LEFT OR %ES_AUTOHSCROLL OR %ES_AUTOVSCROLL OR _  ' class styles
                                 %ES_MULTILINE, _
                                 12, 12, _                                            ' left, top
                                 275, 110, _                                          ' width, height
                                 hWnd, %IDC_FORM1_EDIT1, _                            ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the OK text button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "OK", _                                              ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %BS_PUSHBUTTON OR %BS_CENTER OR %BS_VCENTER, _       ' class styles
                                 71, 128, _                                           ' left, top
                                 75, 23, _                                            ' width, height
                                 hWnd, %IDOK, _                                       ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the Cancel text button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Cancel", _                                          ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %BS_PUSHBUTTON OR %BS_CENTER OR %BS_VCENTER, _       ' class styles
                                 152, 128, _                                          ' left, top
                                 75, 23, _                                            ' width, height
                                 hWnd, %IDCANCEL, _                                   ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Rules
      Layout_AddRule hWnd, %Stretch, %Right, %IDC_FORM1_EDIT1, %Right
      Layout_AddRule hWnd, %Stretch, %Bottom, %IDC_FORM1_EDIT1, %Bottom
      Layout_AddRule hWnd, %HCenter, %Group, MakLng(%IdOk, %IdCancel)
      Layout_AddRule hWnd, %Move, %Bottom, MakLng(%IdOk, %IdCancel), %Bottom
      ' Limits
      Layout_AddLimit hWnd, %Form, 307, 200

      FUNCTION = %FALSE
      EXIT FUNCTION
  END SELECT

  FUNCTION = DefWindowProc(hWnd, uMsg, wParam, lParam)

END FUNCTION
