#Dim All
#REGISTER NONE
#COMPILE EXE
#OPTION VERSION4

%NTDDI_VERSION                          		= &H05010000
%WINVER                                 		= &H0501
%WIN32_WINNT                            		= &H0501
%WIN32_IE                               		= &H0600
%UNICODE                                		= 1

#Include Once "WIN32API.INC"

#Include Once "Layout32_sll.inc"

#Link "Layout32.sll"

#Resource Manifest, 1, "OtherUses.xml"

'--------------------------- [ Control Identifiers ] ---------------------------

' Form1
%IDC_FORM1_FIRSTNAME                        = 101
%IDC_FORM1_LASTNAME                         = 102
%IDC_FORM1_NOTES                            = 103
%IDC_FORM1_FIRSTNAMELBL                     = 104
%IDC_FORM1_LASTNAMELBL                      = 105
%IDC_FORM1_NOTESLBL                         = 106

Global  ghInstance    As DWord    ' handle of the application instance

'-------------------------------------------------------------------------------
'
' PROCEDURE: WinMain
' PURPOSE:   Program entry point, calls initialization function, processes
'            message loop.
'
'-------------------------------------------------------------------------------

FUNCTION WinMain _
  ( _
  BYVAL hInstance     AS DWORD, _         ' handle of current instance
  BYVAL hPrevInstance AS DWORD, _         ' handle of previous instance(not used in Win32)
  BYVAL pszCmdLine    AS WSTRINGZ PTR, _  ' address of command line
  BYVAL nCmdShow      AS LONG _           ' show state of window
  ) AS LONG

  LOCAL szClassName     AS WSTRINGZ * %MAX_PATH     ' class name
  LOCAL twcx            AS WNDCLASSEX               ' class information
  LOCAL tmsg            AS tagMsg                   ' message information
  Local hWnd            As DWord                    ' handle of main window

  ' Save the handle of the application instance
  ghInstance = hInstance

  ' Register the Form1 window
  szClassName        = "Form1_Class"
  twcx.cbSize        = SIZEOF(twcx)                               ' size of WNDCLASSEX structure
  twcx.style         = %CS_DBLCLKS                                ' class styles
  twcx.lpfnWndProc   = CODEPTR(Form1_WndProc)                     ' address of window procedure used by class
  twcx.cbClsExtra    = 0                                          ' extra class bytes
  twcx.cbWndExtra    = 0                                          ' extra window bytes
  twcx.hInstance     = ghInstance                                 ' instance of the process that is registering the window
  twcx.hIcon         = LoadIcon(%NULL, BYVAL %IDI_APPLICATION)    ' handle of class icon
  twcx.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)        ' handle of class cursor
  twcx.hbrBackground = %COLOR_BTNFACE + 1                         ' brush used to fill background of window's client area
  twcx.lpszMenuName  = %NULL                                      ' resource identifier of the class menu
  twcx.lpszClassName = VARPTR(szClassName)                        ' class name
  twcx.hIconSm       = %NULL                                      ' handle of small icon shown in caption/system Taskbar
  If RegisterClassEx(twcx) = 0 Then
    FUNCTION = %FALSE
    EXIT FUNCTION
  END IF

  ' Create the Form1 window
  hWnd = CreateWindowEx(%WS_EX_WINDOWEDGE, _                                          ' extended styles
                        "Form1_Class", _                                              ' class name
                        "Customer Info", _                                            ' caption
                        %WS_OVERLAPPEDWINDOW OR %WS_VISIBLE OR %WS_THICKFRAME OR _    ' window styles
                        %WS_CLIPCHILDREN, _
                        70, 130, _                                                    ' left, top
                        258, 239, _                                                   ' width, height
                        %NULL, %NULL, _                                               ' handle of owner, menu handle
                        ghInstance, BYVAL %NULL)                                      ' handle of instance, creation parameters
  ' If window could not be created, return "failure"
  If hWnd = %NULL Then
    Function = %FALSE
    Exit Function
  End If

  ' Make the window visible; update its client area
  ShowWindow hWnd, nCmdShow
  UpdateWindow hWnd

  ' Main message loop of program.
  ' Acquire and dispatch messages until a WM_QUIT message is received.
  While GetMessage(tmsg, ByVal %NULL, 0, 0) > 0
    If (hWnd = %NULL) Or (IsDialogMessage(hWnd, tmsg) = 0) Then
      TranslateMessage tmsg
      DispatchMessage tmsg
    End If
  Wend

  Function = tmsg.wParam

END FUNCTION

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WndProc
' PURPOSE:   Processes messages for the Form1 window.
'
'-------------------------------------------------------------------------------

FUNCTION Form1_WndProc _
  ( _
  BYVAL hWnd    AS DWORD, _ ' window handle
  BYVAL uMsg    AS DWORD, _ ' type of message
  BYVAL wParam  AS DWORD, _ ' first message parameter
  BYVAL lParam  AS LONG _   ' second message parameter
  ) EXPORT AS LONG

  LOCAL hWndChild     AS DWORD    ' handle of child window
  LOCAL hFont         AS DWORD    ' handle of font used by form

  SELECT CASE uMsg
    CASE %WM_COMMAND

      SELECT CASE LO(WORD, wParam)
        Case %IdOk
          IF HI(WORD, wParam) = %BN_CLICKED THEN
            Layout_Clear hWnd
            ' Rules
            Layout_AddRule hWnd, %Move, %Left, %IDC_FORM1_FIRSTNAMELBL, %Left, %Form, 12
            Layout_AddRule hWnd, %Move, %Top, %IDC_FORM1_FIRSTNAMELBL, %Top, %Form, 15
            Layout_AddRule hWnd, %Stretch, %Right, %IDC_FORM1_FIRSTNAMELBL, %Left, %IDC_FORM1_FIRSTNAMELBL, 63
            Layout_AddRule hWnd, %Stretch, %Bottom, %IDC_FORM1_FIRSTNAMELBL, %Top, %IDC_FORM1_FIRSTNAMELBL, 21

            Layout_AddRule hWnd, %Move, %Left, %IDC_FORM1_FIRSTNAME, %Right, %IDC_FORM1_FIRSTNAMELBL, 6
            Layout_AddRule hWnd, %Move, %Top, %IDC_FORM1_FIRSTNAME, %Top, %Form, 12
            Layout_AddRule hWnd, %Stretch, %Right, %IDC_FORM1_FIRSTNAME, %Right, %Form, -12
            Layout_AddRule hWnd, %Stretch, %Bottom, %IDC_FORM1_FIRSTNAME, %Top, %IDC_FORM1_FIRSTNAME, 21

            Layout_AddRule hWnd, %Move, %Left, %IDC_FORM1_LASTNAMELBL, %Left, %Form, 12
            Layout_AddRule hWnd, %Move, %Top, %IDC_FORM1_LASTNAMELBL, %Top, %Form, 42
            Layout_AddRule hWnd, %Stretch, %Right, %IDC_FORM1_LASTNAMELBL, %Left, %IDC_FORM1_LASTNAMELBL, 63
            Layout_AddRule hWnd, %Stretch, %Bottom, %IDC_FORM1_LASTNAMELBL, %Top, %IDC_FORM1_LASTNAMELBL, 21

            Layout_AddRule hWnd, %Move, %Left, %IDC_FORM1_LASTNAME, %Right, %IDC_FORM1_LASTNAMELBL, 6
            Layout_AddRule hWnd, %Move, %Top, %IDC_FORM1_LASTNAME, %Top, %Form, 39
            Layout_AddRule hWnd, %Stretch, %Right, %IDC_FORM1_LASTNAME, %Right, %Form, -12
            Layout_AddRule hWnd, %Stretch, %Bottom, %IDC_FORM1_LASTNAME, %Top, %IDC_FORM1_LASTNAME, 21


            Layout_AddRule hWnd, %Move, %Left, %IDC_FORM1_NOTES, %Left, %Form, 81
            Layout_AddRule hWnd, %Move, %Top, %IDC_FORM1_NOTES, %Top, %Form, 87
            Layout_AddRule hWnd, %Stretch, %Right, %IDC_FORM1_NOTES, %Right, %Form, -12
            Layout_AddRule hWnd, %Stretch, %Bottom, %IDC_FORM1_NOTES, %Bottom, %Form, -58

            Layout_AddRule hWnd, %HCenter, %Control, %IDC_FORM1_NOTESLBL, %Control, %IDC_FORM1_NOTES
            Layout_AddRule hWnd, %Move, %Bottom, %IDC_FORM1_NOTESLBL, %Top, %IDC_FORM1_NOTES, 0

            Layout_AddRule hWnd, %Move, %Left, %IdCancel, %Right, %IdOk, 6
            Layout_AddRule hWnd, %HCenter, %Group, MakLng(%IdOk, %IdCancel)
            Layout_AddRule hWnd, %Move, %Bottom, MakLng(%IdOk, %IdCancel), %Bottom, %Form, -12

            ' Limits
            Layout_AddLimit hWnd, %Form, 258, 239

            SendMessage hWnd, %WM_Size, 0, 0
          End If

        CASE %IDCANCEL
      End Select

    Case %WM_SetFocus
      ' Set the keyboard focus to the first control that is
      ' visible, not disabled, and has the WS_TABSTOP style
      SetFocus GetNextDlgTabItem(hWnd, %NULL, %FALSE)

    Case %WM_Close

    CASE %WM_QUERYENDSESSION

    CASE %WM_DESTROY
      PostQuitMessage 0
      FUNCTION = %FALSE
      EXIT FUNCTION

    Case %WM_GETFONT
      Function = GetStockObject(%DEFAULT_GUI_FONT)
      Exit Function

    Case %WM_Create
      ' Create and save the font used by the form
      hFont = GetStockObject(%DEFAULT_GUI_FONT)

      ' Create the FirstNameLbl label
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Static", _                                          ' class name
                                 "First Name:", _                                     ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_GROUP OR _
                                 %SS_LEFT, _                                          ' class styles
                                 150, 142, _                                          ' left, top
                                 63, 21, _                                            ' width, height
                                 hWnd, %IDC_FORM1_FIRSTNAMELBL, _                     ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the FirstName edit control
      hWndChild = CreateWindowEx(%WS_EX_CLIENTEDGE, _                                 ' extended styles
                                 "Edit", _                                            ' class name
                                 "", _                                                ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %ES_LEFT OR %ES_AUTOHSCROLL, _                       ' class styles
                                 81, 12, _                                            ' left, top
                                 72, 21, _                                            ' width, height
                                 hWnd, %IDC_FORM1_FIRSTNAME, _                        ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the LastNameLbl label
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Static", _                                          ' class name
                                 "Last Name:", _                                      ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_GROUP OR _
                                 %SS_LEFT, _                                          ' class styles
                                 33, 154, _                                           ' left, top
                                 63, 21, _                                            ' width, height
                                 hWnd, %IDC_FORM1_LASTNAMELBL, _                      ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the LastName edit control
      hWndChild = CreateWindowEx(%WS_EX_CLIENTEDGE, _                                 ' extended styles
                                 "Edit", _                                            ' class name
                                 "", _                                                ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %ES_LEFT OR %ES_AUTOHSCROLL, _                       ' class styles
                                 33, 66, _                                            ' left, top
                                 89, 21, _                                            ' width, height
                                 hWnd, %IDC_FORM1_LASTNAME, _                         ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the NotesLbl label
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Static", _                                          ' class name
                                 "Notes", _                                           ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_GROUP OR _
                                 %SS_CENTER OR %SS_CENTERIMAGE, _                     ' class styles
                                 144, 95, _                                           ' left, top
                                 56, 21, _                                            ' width, height
                                 hWnd, %IDC_FORM1_NOTESLBL, _                         ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the Notes edit control
      hWndChild = CreateWindowEx(%WS_EX_CLIENTEDGE, _                                 ' extended styles
                                 "Edit", _                                            ' class name
                                 "", _                                                ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_HSCROLL OR _         ' window styles
                                 %WS_VSCROLL OR %WS_CLIPSIBLINGS OR %WS_TABSTOP OR _
                                 %ES_LEFT OR %ES_AUTOHSCROLL OR %ES_AUTOVSCROLL OR _  ' class styles
                                 %ES_MULTILINE, _
                                 81, 81, _                                            ' left, top
                                 72, 41, _                                            ' width, height
                                 hWnd, %IDC_FORM1_NOTES, _                            ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the OK text button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "OK(Layout)", _                                      ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %BS_PUSHBUTTON OR %BS_CENTER OR %BS_VCENTER, _       ' class styles
                                 21, 109, _                                           ' left, top
                                 75, 23, _                                            ' width, height
                                 hWnd, %IDOK, _                                       ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the Cancel text button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Cancel", _                                          ' caption
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR _    ' window styles
                                 %WS_TABSTOP OR _
                                 %BS_PUSHBUTTON OR %BS_CENTER OR %BS_VCENTER, _       ' class styles
                                 138, 66, _                                           ' left, top
                                 75, 23, _                                            ' width, height
                                 hWnd, %IDCANCEL, _                                   ' handle of parent, control ID
                                 ghInstance, BYVAL %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE
  End Select

  FUNCTION = DefWindowProc(hWnd, uMsg, wParam, lParam)

END FUNCTION

