#Dim All
#Register None
#Compile Exe
#Option Version4

' Notes
' This sample demonstrates symmetrical resizing of two list-boxes on a form.

' The following constants define the minimum required platform.  The minimum required
' platform is the earliest version of Windows, Internet Explorer etc. that has the
' necessary features to run your application.  Wnen defined, they enable features
' available on platform versions up to and including the version specified.
%NTDDI_VERSION                          		= &H05010000
%WINVER                                 		= &H0501
%WIN32_WINNT                            		= &H0501
%WIN32_IE                               		= &H0600
%UNICODE                                		= 1

#Include Once "WIN32API.INC"

#Include Once "Layout32_sll.inc"

#Link "Layout32.sll"

#Resource Manifest, 1, "Symmetry.xml"

'--------------------------- [ Control Identifiers ] ---------------------------

%IDC_FORM1_TEXTBTN3                         = 101
%IDC_FORM1_TEXTBTN4                         = 102
%IDC_FORM1_LIST1                            = 103
%IDC_FORM1_TEXTBTN5                         = 104
%IDC_FORM1_TEXTBTN6                         = 105
%IDC_FORM1_LIST2                            = 106

Global  ghInstance      As DWord    ' handle of the application instance

'-------------------------------------------------------------------------------
'
' PROCEDURE: WinMain
' PURPOSE:   Program entry point, calls initialization function, processes
'            message loop.
'
'-------------------------------------------------------------------------------

Function WinMain _
  ( _
  ByVal hInstance     As DWord, _         ' handle of current instance
  ByVal hPrevInstance As DWord, _         ' handle of previous instance(not used in Win32)
  ByVal pszCmdLine    As WStringZ Ptr, _  ' address of command line
  ByVal nCmdShow      As Long _           ' show state of window
  ) As Long

  Local szClassName     As WStringZ * %Max_Path     ' class name
  Local twcx            As WNDCLASSEX               ' class information
  Local tmsg            As tagMsg                   ' message information
  Local hWnd            As DWord                    ' handle of main window

  ' Save the handle of the application instance
  ghInstance = hInstance

  ' Register the Form1 window
  szClassName        = "Form1_Class"
  twcx.cbSize        = SizeOf(twcx)                               ' size of WNDCLASSEX structure
  twcx.style         = %CS_DBLCLKS                                ' class styles
  twcx.lpfnWndProc   = CodePtr(Form1_WndProc)                     ' address of window procedure used by class
  twcx.cbClsExtra    = 0                                          ' extra class bytes
  twcx.cbWndExtra    = 0                                          ' extra window bytes
  twcx.hInstance     = ghInstance                                 ' instance of the process that is registering the window
  twcx.hIcon         = LoadIcon(%NULL, ByVal %IDI_APPLICATION)    ' handle of class icon
  twcx.hCursor       = LoadCursor(%NULL, ByVal %IDC_ARROW)        ' handle of class cursor
  twcx.hbrBackground = %COLOR_BTNFACE + 1                         ' brush used to fill background of window's client area
  twcx.lpszMenuName  = %NULL                                      ' resource identifier of the class menu
  twcx.lpszClassName = VarPtr(szClassName)                        ' class name
  twcx.hIconSm       = %NULL                                      ' handle of small icon shown in caption/system Taskbar
  If RegisterClassEx(twcx) = 0 Then
    Function = %FALSE
    Exit Function
  End If

  ' Create the Form1 window
  hWnd = CreateWindowEx(%WS_Ex_Windowedge, _                                          ' extended styles
                        "Form1_Class", _                                              ' class name
                        "Symmetry", _                                                 ' caption
                        %WS_OverlappedWindow Or %WS_Visible Or %WS_ClipChildren, _    ' window styles
                        70, 130, _                                                    ' left, top
                        360, 323, _                                                   ' width, height
                        %NULL, %NULL, _                                               ' handle of owner, menu handle
                        ghInstance, ByVal %NULL)                                      ' handle of instance, creation parameters
  ' If window could not be created, return "failure"
  If hWnd = %NULL Then
    Function = %FALSE
    Exit Function
  End If

  ' Make the window visible; update its client area
  ShowWindow hWnd, nCmdShow
  UpdateWindow hWnd

  ' Main message loop of program.
  ' Acquire and dispatch messages until a WM_QUIT message is received.
  While GetMessage(tmsg, ByVal %NULL, 0, 0) > 0
    If (hWnd = %NULL) Or (IsDialogMessage(hWnd, tmsg) = 0) Then
      TranslateMessage tmsg
      DispatchMessage tmsg
    End If
  Wend

  Function = tmsg.wParam

End Function

'-------------------------------------------------------------------------------
'
' PROCEDURE: Form1_WndProc
' PURPOSE:   Processes messages for the Form1 window.
'
'-------------------------------------------------------------------------------

Function Form1_WndProc _
  ( _
  ByVal hWnd    As DWord, _ ' window handle
  ByVal uMsg    As DWord, _ ' type of message
  ByVal wParam  As DWord, _ ' first message parameter
  ByVal lParam  As Long _   ' second message parameter
  ) Export As Long

  Local szItem        As WStringZ * %Max_Path   ' working variable
  Local hWndChild     As DWord                  ' handle of child window
  Local hFont         As DWord                  ' handle of font used by form

  Select Case uMsg
    Case %WM_Command

    Case %WM_SetFocus
      ' Set the keyboard focus to the first control that is
      ' visible, not disabled, and has the WS_TABSTOP style
      SetFocus GetNextDlgTabItem(hWnd, %NULL, %FALSE)

    Case %WM_Close

    Case %WM_QUERYENDSESSION

    Case %WM_Destroy
      PostQuitMessage 0
      Function = %FALSE
      Exit Function

    Case %WM_GETFONT
      Function = GetStockObject(%DEFAULT_GUI_FONT)
      Exit Function

    Case %WM_Create
      ' Create and save the font used by the form
      hFont = GetStockObject(%DEFAULT_GUI_FONT)

      ' Create the List1 listbox
      hWndChild = CreateWindowEx(%WS_Ex_ClientEdge, _                                 ' extended styles
                                 "Listbox", _                                         ' class name
                                 "", _                                                ' caption
                                 %WS_Child Or %WS_Visible Or %WS_VScroll Or _         ' window styles
                                 %WS_Border Or %WS_TabStop Or _
                                 %LBS_NoIntegralHeight Or %LBS_HasStrings Or _        ' class styles
                                 %LBS_Notify, _
                                 12, 12, _                                            ' left, top
                                 328, 99, _                                           ' width, height
                                 hWnd, %IDC_FORM1_LIST1, _                            ' handle of parent, control ID
                                 ghInstance, ByVal %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Add the initial items
      ' Turn off repainting
      SendMessage hWndChild, %WM_SETREDRAW, %FALSE, 0
      szItem = "Trinidad and Tobago"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Grenada"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "St. Vincent"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "St. Lucia"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Martinique"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Dominica"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Guadeloupe"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Montserrat"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Antigua"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "St. Kitts and Nevis"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Puerto Rico"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Dominican Republic"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Haiti"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Jamaica"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Cuba"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Bahamas"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      ' Turn on repainting
      SendMessage hWndChild, %WM_SETREDRAW, %TRUE, 0
      InvalidateRect hWndChild, ByVal %NULL, %TRUE
      UpdateWindow hWndChild

      ' Create the TextBtn3 text button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Get", _                                              ' caption
                                 %WS_Child Or %WS_Visible Or %WS_ClipSiblings Or _    ' window styles
                                 %WS_TabStop Or _
                                 %BS_PushButton Or %BS_Center Or %BS_VCenter, _       ' class styles
                                 98, 117, _                                           ' left, top
                                 75, 23, _                                            ' width, height
                                 hWnd, %IDC_FORM1_TEXTBTN3, _                         ' handle of parent, control ID
                                 ghInstance, ByVal %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the TextBtn4 text button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Set   ", _                                          ' caption
                                 %WS_Child Or %WS_Visible Or %WS_ClipSiblings Or _    ' window styles
                                 %WS_TabStop Or _
                                 %BS_PushButton Or %BS_Center Or %BS_VCenter, _       ' class styles
                                 179, 117, _                                          ' left, top
                                 75, 23, _                                            ' width, height
                                 hWnd, %IDC_FORM1_TEXTBTN4, _                         ' handle of parent, control ID
                                 ghInstance, ByVal %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the List2 listbox
      hWndChild = CreateWindowEx(%WS_Ex_ClientEdge, _                                 ' extended styles
                                 "Listbox", _                                         ' class name
                                 "", _                                                ' caption
                                 %WS_Child Or %WS_Visible Or %WS_VScroll Or _         ' window styles
                                 %WS_Border Or %WS_TabStop Or _
                                 %LBS_NoIntegralHeight Or %LBS_HasStrings Or _        ' class styles
                                 %LBS_Notify, _
                                 12, 146, _                                           ' left, top
                                 328, 99, _                                           ' width, height
                                 hWnd, %IDC_FORM1_LIST2, _                            ' handle of parent, control ID
                                 ghInstance, ByVal %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Add the initial items
      ' Turn off repainting
      SendMessage hWndChild, %WM_SETREDRAW, %FALSE, 0
      szItem = "Trinidad and Tobago"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Grenada"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "St. Vincent"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "St. Lucia"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Martinique"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Dominica"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Guadeloupe"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Montserrat"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Antigua"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "St. Kitts and Nevis"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Puerto Rico"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Dominican Republic"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Haiti"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Jamaica"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Cuba"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      szItem = "Bahamas"
      SendMessage hWndChild, %LB_ADDSTRING, 0, ByVal VarPtr(szItem)
      ' Turn on repainting
      SendMessage hWndChild, %WM_SETREDRAW, %TRUE, 0
      InvalidateRect hWndChild, ByVal %NULL, %TRUE
      UpdateWindow hWndChild

      ' Create the TextBtn5 text button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Get", _                                             ' caption
                                 %WS_Child Or %WS_Visible Or %WS_ClipSiblings Or _    ' window styles
                                 %WS_TabStop Or _
                                 %BS_PushButton Or %BS_Center Or %BS_VCenter, _       ' class styles
                                 98, 251, _                                           ' left, top
                                 75, 23, _                                            ' width, height
                                 hWnd, %IDC_FORM1_TEXTBTN5, _                         ' handle of parent, control ID
                                 ghInstance, ByVal %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Create the TextBtn6 text button
      hWndChild = CreateWindowEx(0, _                                                 ' extended styles
                                 "Button", _                                          ' class name
                                 "Set", _                                             ' caption
                                 %WS_Child Or %WS_Visible Or %WS_ClipSiblings Or _    ' window styles
                                 %WS_TabStop Or _
                                 %BS_PushButton Or %BS_Center Or %BS_VCenter, _       ' class styles
                                 179, 251, _                                          ' left, top
                                 75, 23, _                                            ' width, height
                                 hWnd, %IDC_FORM1_TEXTBTN6, _                         ' handle of parent, control ID
                                 ghInstance, ByVal %NULL)                             ' handle of instance, creation parameters
      SendMessage hWndChild, %WM_SETFONT, hFont, %TRUE

      ' Rules
      Layout_AddRule hWnd, %Move, %Top, %IDC_FORM1_LIST2, %Height
      Layout_AddRule hWnd, %Stretch, %Right, %IDC_FORM1_LIST2, %Right
      Layout_AddRule hWnd, %Stretch, %Bottom, %IDC_FORM1_LIST2, %Bottom
      Layout_AddRule hWnd, %Move, %Top, MakLng(%IDC_FORM1_TEXTBTN5, %IDC_FORM1_TEXTBTN6), %Bottom
      Layout_AddRule hWnd, %HCenter, %Group, MakLng(%IDC_FORM1_TEXTBTN5, %IDC_FORM1_TEXTBTN6)

      Layout_AddRule hWnd, %Stretch, %Right, %IDC_FORM1_LIST1, %Right
      Layout_AddRule hWnd, %Stretch, %Bottom, %IDC_FORM1_LIST1, %Top, %IDC_FORM1_LIST2
      Layout_AddRule hWnd, %Move, %Top, MakLng(%IDC_FORM1_TEXTBTN3, %IDC_FORM1_TEXTBTN4), %Bottom, %IDC_FORM1_LIST1
      Layout_AddRule hWnd, %HCenter, %Group, MakLng(%IDC_FORM1_TEXTBTN3, %IDC_FORM1_TEXTBTN4)

      ' Limits
      Layout_AddLimit hWnd, %Form, 360, 323
  End Select

  Function = DefWindowProc(hWnd, uMsg, wParam, lParam)

End Function

